<app-loading *ngIf="isLoading"></app-loading>
<div id='request-form'>
  <form nz-form [formGroup]="form" class="content__item content__item--border bg__content--default" scroll-spy>
    <div nz-row [nzGutter]="[30,30]">
      <!-- Người làm đơn -->
      <ng-container *ngIf="!requestId && objFunction?.edit">
        <div nz-col nzXs="24" nzLg="6">
          <mb-select [mbDataSelects]="PERSONAL_TYPE_DATASOURCE"
            mbLabelText="{{'selfService.label.requestsPerson' | translate}}" [mbOptionHeightPx]="56"
            [mbOptionOverflowSize]="2" mbPlaceholder="{{'selfService.label.requestsPerson' | translate}}"
            [formControlName]="'personalType'" (ngModelChange)="onChangePersonalType()"></mb-select>
        </div>
        <div *ngIf="f['personalType'].value === PERSONAL_TYPE.OTHER" nz-col [nzXs]="24" [nzLg]="6"
          class="area-select-employee">
          <employee-data-picker [mbCanText]='true'
            [mbType]="isSubmitted && f['employeeId'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && f['employeeId'].errors !== null"
            [mbErrors]="f['employeeId'].errors"
            status="WORKING"
            [mbErrorDefs]="[
                { errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.label.requestsPerson' | translate}},
                { errorName: 'personalTypeOther', errorDescription: 'selfService.validate.personalTypeOther' | translate}
            ]"
            (selectedChange)="changeEmployee($event)"
            [formControlName]="'employeeId'">
          </employee-data-picker>
        </div>
      </ng-container>
      <ng-container *ngIf="this.requestId">
        <div nz-col [nzXs]="24" [nzLg]="6">
          <mb-text-label mbLabelText="{{'selfService.label.requestsPerson' | translate}}"
            [mbLabelValue]="f['fullName'].value + '-' + f['employeeCode'].value">
          </mb-text-label>
        </div>
      </ng-container>
      <!-- Danh sách loại đơn -->
      <div nz-col [nzXs]="24" [nzLg]="24">
        <ng-container formArrayName="listAbsRequestLeaves">
          <ng-container *ngFor="let reason of reasons.controls; let i = index; let first = first">
            <div nz-row [nzGutter]="[30, 10]" class="direct__managers" [formGroupName]="i">
              <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-select [mbDataSelects]="listReasonLeave" mbKeyLabel="name" mbKeyValue="reasonLeaveId"
                  [mbType]="isSubmitted && reason['controls']['reasonLeaveId'].errors ? 'error' : 'default'"
                  [mbShowError]="isSubmitted && reason['controls']['reasonLeaveId'].errors !== null"
                  [mbErrors]="reason['controls']['reasonLeaveId'].errors" [mbDisable]="screenMode === SCREEN_MODE.VIEW"
                  [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.label.reasonLeave' | translate}}]"
                  mbLabelText="{{'selfService.label.reasonLeave' | translate}} <span class='label__required'>*</span>" [mbOptionHeightPx]="56"
                  mbPlaceholder="{{'selfService.label.reasonLeave' | translate}}"
                  [formControlName]="'reasonLeaveId'" (ngModelChange)="onChangeReason(i)"></mb-select>
              </div>
              <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-date-time-work [mbDisabled]="screenMode === SCREEN_MODE.VIEW"
                  [mbType]="isSubmitted && reason['controls']['fromTime'].errors  ? 'error' : 'default'"
                  [mbShowError]="isSubmitted && reason['controls']['fromTime'].errors !== null"
                  [mbErrors]="isSubmitted && reason['controls']['fromTime'].errors"
                  [mbErrorDefs]="[
                    { errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.label.fromTime' | translate}},
                    { errorName: 'dublicateTime', errorDescription: 'selfService.validate.dublicateTime' | translate}
                  ]"
                  mbPlaceholderText="{{'selfService.label.fromTime' | translate}}"
                  mbLabelText="{{'selfService.label.fromTime' | translate}} <span class='label__required'>*</span>" [formControlName]="'fromTime'"
                  (ngModelChange)="onChangeReason(i)"></mb-date-time-work>
              </div>
              <div nz-col [nzXs]="24" [nzLg]="6">
                <mb-date-time-work
                  [mbIsStartTime]="false" [mbDisabled]="screenMode === SCREEN_MODE.VIEW"
                  [mbType]="isSubmitted && (reason['controls']['toTime'].errors || reason.errors) ? 'error' : 'default'"
                  [mbShowError]="isSubmitted && (reason['controls']['toTime'].errors || reason.errors) !== null"
                  [mbErrors]="reason['controls']['toTime'].errors ? reason['controls']['toTime'].errors : ( reason.errors ? reason.errors : null)"
                  [mbErrorDefs]="[
                    { errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.label.toTime' | translate}},
                    { errorName: 'rangeDateError', errorDescription: 'selfService.validate.rangeDate.pareDateMore' | translate: {toDate: 'selfService.label.toTime' | translate, fromDate: 'selfService.label.fromTime' | translate}},
                    { errorName: 'dublicateTime', errorDescription: 'selfService.validate.dublicateTime' | translate}
                  ]"
                  mbPlaceholderText="{{'selfService.label.toTime' | translate}}"
                  mbLabelText="{{'selfService.label.toTime' | translate}} <span class='label__required'>*</span>" [formControlName]="'toTime'"
                  (ngModelChange)="onChangeReason(i)"></mb-date-time-work>
              </div>
              <div *ngIf="screenMode !== SCREEN_MODE.VIEW" nz-col [nzXs]="24" [nzLg]="6" class="area-action">
                <button class="cus-button cus-button-add far fa-plus-circle" (click)="addReason()"></button>
                <button class="cus-button cus-button-remove far fa-trash-alt" (click)="removeReason(i)"></button>
              </div>
            </div>
          </ng-container>
        </ng-container>
      </div>
      <div nz-col [nzXs]="24" [nzLg]="6">
        <mb-text-label mbLabelText="{{'selfService.label.numberDayLeave' | translate}}"
          [mbLabelValue]="f['allDays'].value">
        </mb-text-label>
      </div>
      <div nz-col [nzXs]="24" [nzLg]="6">
        <mb-text-label mbLabelText="{{'selfService.label.numberDayWorkLeave' | translate}}"
          [mbLabelValue]="f['totalDays'].value">
        </mb-text-label>
      </div>


      <div nz-col [nzXs]="24" [nzLg]="18">
        <mb-input-text formControlName="reasonDetail" [mbIsTextAre]='true' [mbMaxLength]="2000" [mbConfig]="{ rows: 1, autoSize: true }"
          [mbType]="isSubmitted && f['reasonDetail'].errors ? 'error' : 'default'" [mbDisable]="screenMode === SCREEN_MODE.VIEW"
          [mbShowError]="isSubmitted && f['reasonDetail'].errors !== null" [mbErrors]="f['reasonDetail'].errors"
          [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'selfService.validate.maxLength' | translate: {'numberLength': '2000' }}]"
          mbPlaceholderText="{{'selfService.label.reasonDetail' | translate}}"
          mbLabelText="{{'selfService.label.reasonDetail' | translate}}"></mb-input-text>
      </div>
      <!-- Danh sách người tiếp nhận -->
      <div nz-col [nzXs]="24" [nzLg]="24">
        <ng-container formArrayName="listAbsRequestSupporters">
          <ng-container *ngFor="let supporter of supporters.controls; let i = index; let first = first">
            <div nz-row [nzGutter]="[30, 10]" class="direct__managers" [formGroupName]="i">
              <div nz-col [nzXs]="24" [nzLg]="9">
                <employee-data-picker [mbCanText]='true' [mbDisable]="screenMode === SCREEN_MODE.VIEW"
                  [mbType]="isSubmitted && supporter['controls']['employeeId'].errors ? 'error' : 'default'"
                  [mbShowError]="isSubmitted && supporter['controls']['employeeId'].errors !== null"
                  [mbErrors]="supporter['controls']['employeeId'].errors"
                  status="WORKING"
                  [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.label.supporter' | translate}}
                                ,{ errorName: 'duplicate', errorDescription: 'selfService.validate.duplicate' | translate }
                                ,{ errorName: 'duplicateEmployee', errorDescription: 'selfService.validate.duplicateEmployee' | translate }]"
                  [formControlName]="'employeeId'" mbLabelText="{{'selfService.label.supporter' | translate}} <span class='label__required'>*</span>">
                </employee-data-picker>
              </div>

              <div nz-col [nzXs]="24" [nzLg]="9">
                <mb-input-text formControlName="taskContent" [mbMaxLength]="2000" [mbIsTextAre]='true' [mbConfig]="{ rows: 1, autoSize: true }"
                  [mbType]="isSubmitted && supporter['controls']['taskContent'].errors ? 'error' : 'default'"
                  [mbShowError]="isSubmitted && supporter['controls']['taskContent'].errors !== null"
                  [mbErrors]="supporter['controls']['taskContent'].errors" [mbDisable]="screenMode === SCREEN_MODE.VIEW"
                  [mbErrorDefs]="[
                    { errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.label.taskContent' | translate}}
                    , { errorName: 'maxlength', errorDescription: 'selfService.validate.maxLength' | translate: {'numberLength': '2000' }}
                  ]"
                  mbPlaceholderText="{{'selfService.label.taskContent' | translate}}"
                  mbLabelText="{{'selfService.label.taskContent' | translate}} <span class='label__required'>*</span>"></mb-input-text>
              </div>

              <div *ngIf="screenMode !== SCREEN_MODE.VIEW" nz-col [nzXs]="24" [nzLg]="6" class="area-action">
                <button class="cus-button cus-button-add far fa-plus-circle" (click)="addSupporter()"></button>
                <button class="cus-button cus-button-remove far fa-trash-alt" (click)="removeSupporter(i)"></button>
              </div>
            </div>
          </ng-container>
        </ng-container>
      </div>
      <!-- Người xét duyệt - Người phê duyệt start -->
      <div *ngIf="approvers.controls.length > 0" nz-col [nzXs]="24" [nzLg]="24">
        <ng-container formArrayName="listAbsRequestApprovers">
          <ng-container *ngFor="let approver of approvers.controls; let i = index; let first = first">
            <div class="area-select-employee" [formGroupName]="i">
                <div class="leaves-approver" nz-row [nzGutter]="[30,30]">
                    <div class="approver-switch" nz-col [nzXs]="4" [nzLg]="2">
                        <div class="input__group">
                            <label class="input__label">{{'selfService.label.selectSuggest' | translate}}</label>
                            <div>
                                <nz-switch
                                    [formControlName]="'isSuggest'"
                                    [nzDisabled]="screenMode === SCREEN_MODE.VIEW || approver['controls']['disableSuggest'].value === 1"
                                    (ngModelChange)="switchApproverSelector(approver)"
                                ></nz-switch>
                            </div>
                        </div>
                    </div>
                    <div class="approver-selector" nz-col [nzXs]="14" [nzLg]="16">
                      <ng-container *ngIf="approver['controls']['isSuggest'].value; else employeeDataPickerTm">
                        <mb-select [mbDataSelects]="approver['controls']['approvers'].value"
                            mbLabelText="{{approver['controls']['title'].value}} <span class='label__required'>{{approver['controls']['isApprover'].value ? '*' : ''}}</span>"
                            [mbOptionHeightPx]="56"
                            [mbOptionOverflowSize]="5" [mbPlaceholder]="approver['controls']['title'].value"
                            [mbType]="isSubmitted && approver['controls']['employeeId'].errors ? 'error' : 'default'"
                            [mbShowError]="isSubmitted && approver['controls']['employeeId'].errors !== null"
                            [mbErrors]="approver['controls']['employeeId'].errors" mbKeyLabel="nameCode" mbKeyValue="employeeId"
                            [mbDisable]="screenMode === SCREEN_MODE.VIEW"
                            [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': approver['controls']['title'].value}}]"
                            [formControlName]="'employeeId'"></mb-select>
                      </ng-container>
                      <ng-template #employeeDataPickerTm>
                        <employee-data-picker [mbCanText]='true' [mbDisable]="screenMode === SCREEN_MODE.VIEW"
                          [mbType]="isSubmitted && approver['controls']['employeeId'].errors ? 'error' : 'default'"
                          [mbShowError]="isSubmitted && approver['controls']['employeeId'].errors !== null"
                          [mbErrors]="approver['controls']['employeeId'].errors"
                          [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': approver['controls']['title'].value}}]"
                          [formControlName]="'employeeId'"
                          status="WORKING"
                          mbLabelText="{{approver['controls']['title'].value}} <span class='label__required'>{{approver['controls']['isApprover'].value ? '*' : ''}}</span>">
                        </employee-data-picker>
                      </ng-template>
                    </div>
                    <div *ngIf="screenMode !== SCREEN_MODE.VIEW" class="approver-actions" nz-col [nzXs]="4" [nzLg]="4">
                      <button class="cus-button cus-button-add far fa-plus-circle" (click)="addApprover(i)"></button>
                      <button class="cus-button cus-button-remove far fa-trash-alt" (click)="removeApprover(i)"></button>
                    </div>
                </div>
            </div>
          </ng-container>
        </ng-container>
      </div>
      <!-- Người xét duyệt - Người phê duyệt end -->
      <!-- File đính kèm -->
      <div nz-col [nzXs]="24" [nzLg]="18">
        <label class="input__label">{{'selfService.label.file' | translate}}</label>
        <nz-upload
          nzType="drag"
          [nzMultiple]=" true"
          [(nzFileList)]="fileList"
          [nzBeforeUpload]="beforeUpload"
          [nzRemove]="removeFile"
          [nzDownload]="downloadFile"
          [nzDisabled]="screenMode === SCREEN_MODE.VIEW"
          nzAccept=".TIF, .JPG, .GIF, .PNG, .PDF, .XLS, .XLSX"
        >
          <p class="ant-upload-drag-icon">
            <em nz-icon nzType="inbox"></em>
          </p>
          <p class="ant-upload-text">{{'common.upload.description'|translate}}</p>
          <p class="ant-upload-hint">
            {{'common.upload.requestFormUploadHint'|translate}}
          </p>
        </nz-upload>
      </div>
      <div *ngIf="screenMode !== SCREEN_MODE.VIEW && isLeave" nz-col [nzXs]="24" [nzLg]="18">
        <label nz-checkbox formControlName="isCommitted" nzDisabled="true">
          <span id="committed-label">{{ 'selfService.label.committed' | translate}}</span>
        </label>
      </div>
      <div nz-col [nzXs]="24" [nzLg]="18" class='btn-top-right'>
        <!-- Phe duyet -->
        <mb-button *ngIf="screenMode === SCREEN_MODE.VIEW && viewActionApproval" mbButtonSize='SMALL' mbButtonAvailableStyle='PRIMARY'
          mbButtonText="{{'selfService.table.action.approve' | translate}}" nz-popconfirm nzPopconfirmTitle="{{'selfService.table.action.confirmApprove' | translate}}"
          nzCancelText="{{'selfService.table.action.cancel2' | translate}}" nzOkType="primary"
          nzOkText="{{'selfService.table.action.yes' | translate}}" (nzOnConfirm)="actionApprove()"></mb-button>

        <!-- Tu choi -->
        <mb-button *ngIf="screenMode === SCREEN_MODE.VIEW && viewActionApproval" mbButtonSize='SMALL' mbButtonAvailableStyle='PRIMARY'
          mbButtonText="{{'selfService.table.action.reject' | translate}}"
          (click)="actionReject(allowApprove, footerRejectTmpl)"></mb-button>

        <mb-button *ngIf="screenMode === SCREEN_MODE.CREATE || screenMode === SCREEN_MODE.UPDATE" mbButtonSize='SMALL' mbButtonAvailableStyle='PRIMARY'
          mbButtonText="{{'selfService.label.save' | translate}}" (click)="onSave()"></mb-button>

        <mb-button *ngIf="screenMode === SCREEN_MODE.CREATE || screenMode === SCREEN_MODE.UPDATE" mbButtonSize='SMALL' mbButtonAvailableStyle='PRIMARY' [mbIsDisable]="!f['isCommitted'].value && isLeave"
          mbButtonText="{{'selfService.label.send' | translate}}" (click)="onSave(REQUEST_STATUS.WAIT_APPROVE)"></mb-button>
        <mb-button *ngIf="screenMode === SCREEN_MODE.AJUST" mbButtonSize='SMALL' mbButtonAvailableStyle='PRIMARY' [mbIsDisable]="!f['isCommitted'].value"
          mbButtonText="{{'selfService.label.ajust' | translate}}" (click)="onSave(REQUEST_STATUS.AJUST)"></mb-button>

        <mb-button mbButtonSize='SMALL' mbButtonAvailableStyle='DEFAULT' (click)="onCancel()"
                   mbButtonText="{{'selfService.label.cancel' | translate}}"></mb-button>
      </div>
    </div>
  </form>
</div>


<ng-template #footerRejectTmpl>
  <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="modal.destroy()" mbButtonBgColor="transparent"
    mbButtonText="{{'common.button.cancel' | translate}}"></mb-button>
  <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="modal.getContentComponent().save()"
    mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'common.button.save' | translate}}"></mb-button>
</ng-template>